set ApplicationSecondaire 1
source [file join [file dirname [info script]] texte.tcl]

proc NomFichierCompletOcaml {nom} {
  global CheminAbsolu
  file join $CheminAbsolu ocaml $nom
}

set ocaml [open "|ocamlrun ocaml -I [file join $CheminAbsolu ocaml] $argvbis" r+]
unset argvbis
fconfigure $ocaml -blocking 0 -buffering none

set typesfichiers {
    {{Fichiers Caml}  {.ml .mli}}
    {{Tous fichiers}   *}}

##########################################################################
#
#                Procdures d'change avec OCAML
#
#  "EnvoiOcaml envoi"     envoie "envoi"  ocaml et renvoie la rponse sur ww
#  "EnvoiOcamlFich envoi" idem par l'intermdiaire d'un fichier "tmp.ml"
#
##########################################################################


proc EnvoiSimpleOcaml {envoi} {
  global ocaml
  puts $ocaml $envoi
  flush $ocaml
}

set NombreCanvas 0
set ModeGraphique 0
set canvas_name {}

proc CanvasMark { x y can} {
        global canvas
        # Map from view coordinates to canvas coordinates
        set x [$can canvasx $x]
        set y [$can canvasy $y]
        # Remember the object and its location
        set canvas($can,obj) [$can find closest $x $y]
        set canvas($can,x) $x
        set canvas($can,y) $y
}
proc CanvasDrag { x y can} {
        global canvas
        # Map from view coordinates to canvas coordinates
        set x [$can canvasx $x]
        set y [$can canvasy $y]
        # Move the current object
        set dx [expr $x - $canvas($can,x)]
        set dy [expr $y - $canvas($can,y)]
        $can move $canvas($can,obj) $dx $dy
        set canvas($can,x) $x
        set canvas($can,y) $y
}

proc open_graph {l h} {
  global ww NombreCanvas ModeGraphique largeur_ecran hauteur_ecran \
    FinModeGraphique canvas_name
  set FinModeGraphique 0
  $ww.text yview end
  if {$ModeGraphique} {
    $ww.text insert end \
      "Appel  \"open_canvas\" ignor (utiliser close_canvas ())\n"
  } else {
    incr NombreCanvas
    set ModeGraphique 1
    set canvas_name $ww.text.w$NombreCanvas
    set m m
    canvas $canvas_name -width $l$m -height $h$m -bg grey -cursor arrow
    $ww.text window create end -window $canvas_name
    $canvas_name bind movable <Button-1> {CanvasMark %x %y %W}
    $canvas_name  bind movable <B1-Motion> {CanvasDrag %x %y %W}
  }
}

proc close_graph {} {
   global FinModeGraphique canvas_name ww
   set FinModeGraphique 1
   set canvas_name {}
   $ww.text insert end "\n"
}

$w.text tag configure erreurocaml -background grey75

proc TraiteUneLigne {l} {
  global w ww ModeGraphique FinModeGraphique
  if {"$l"!=""} {
    if {$ModeGraphique} {
      if {$FinModeGraphique} {
        set ModeGraphique 0
        set FinModeGraphique 0
      }
    } else {
      $ww.text see end
    }
    set l [string trimleft $l " #"]
    if {[string first "&&&&" $l]==0} {
      uplevel #0 [string trimleft $l "&"]
    } else {
      set i [string first "tmp.ml\", line " $l]
      if {"$i" != "-1" && [string first "File " $l] == "0"} {
        set i [expr $i+14]
        set j [expr [string wordend $l $i]-1]
        set ligne [string range $l $i $j]
        set i [expr $j+14]
        set j [expr [string wordend $l $i]-1]
        set deb [string range $l $i $j]
        set debut "$ligne.$deb"
        set i [expr $j+2]
        set j [expr [string wordend $l $i]-1]
        set fin "$debut +[expr [string range $l $i $j]-$deb] chars"
        set taguer [$w.text get $debut $fin]
        for {set i 0} {$i<[string length $taguer]} {incr i} {
          if {[string index $taguer $i]=="\n"} {set fin "$fin -1 chars"}
        }
        $w.text tag add erreurocaml $debut $fin
        $w.text see $debut
      } else {
        $ww.text insert end "$l\n"
      }
    }
  }
}

proc EnvoiOcaml {envoi} {
  global ww ocaml
  EnvoiSimpleOcaml $envoi
  fileevent $ocaml readable [list Lecteur_ocaml]
  vwait Fin_attente
}

proc Lecteur_ocaml {} {
  global Fin_attente  ocaml
  if {[gets $ocaml line] < 0} {set Fin_attente 1} {TraiteUneLigne $line}
}

toplevel .ocaml

wm title .ocaml Rsultats
wm positionfrom .ocaml user
wm sizefrom .ocaml user
wm geometry .ocaml \
  [expr $largeur_ecran]x[expr $hauteur_ecran/3]+0+[expr $hauteur_texte+25]
wm protocol .ocaml WM_DELETE_WINDOW {
  destroy .ocaml
  for {set n 0} {$n <= 2} {incr n} {
    $MenuOcaml entryconfigure $n -state disabled
  }
}

set ww .ocaml.ff
frame $ww
pack configure $ww -side left -fill both -expand 1
scrollbar $ww.scrollv -orient vertical -command "$ww.text yview"
pack configure $ww.scrollv -side right -fill y -expand 1
pack configure $ww -side top -expand 1 -fill both

text $ww.text -background grey -relief flat -bd 2 -wrap none \
 -font {-family courier -size 10} -yscrollcommand "$ww.scrollv set"
pack $ww.text -expand yes -fill both


proc EnvoiOcamlFich {envoi} {
  set f [open [NomFichierCompletOcaml tmp.ml] w]
  puts $f $envoi
  close $f
  EnvoiOcaml "#use\"[NomFichierCompletOcaml tmp.ml]\";;\n"
}

proc InclureToutOcaml {} {
     global w
     $w.text tag remove erreurocaml 1.0 end
     EnvoiOcamlFich [$w.text get 1.0 end]
}

proc InclureBlocOcaml {} {
     global w
     $w.text tag remove erreurocaml 1.0 end
     set i "[$w.text search ";;" "insert linestart" end] +2 chars"
     if {$i==" +2 chars"} {
       tk_messageBox -message "Le curseur n'est pas dans un bloc dlimit par des ;;" \
          -title "Erreur" -icon error
       } {
       set i2 $i
       set i "[$w.text search -backward ";;" "insert linestart" 1.0] +2 chars"
       if {$i==" +2 chars"} {set i1 "1.0"} {set i1 $i}
       set i [expr [string range $i1 0 [expr [string first . $i1]-1]]-1]
       set envoi [string repeat "\n" $i]
       append envoi [$w.text get $i1 $i2]
       EnvoiOcamlFich $envoi
       }
}

set MenuOcaml [menu $w.menubar.ocaml -tearoff 1]
  $w.menubar add cascade -label Ocaml -underline 0 -menu $MenuOcaml
  $MenuOcaml add command -label {Inclure tout dans Ocaml} -underline 0 \
    -accelerator {(Shift Entre)} -command {InclureToutOcaml}
     bind $w.text <Shift-Return> {$MenuOcaml invoke 1; break}
  $MenuOcaml add command -label {Inclure bloc dans Ocaml} -underline 8 \
    -accelerator {(Ctrl Entre)} -command {InclureBlocOcaml}
     bind $w.text <Control-Return> {$MenuOcaml invoke 2; break}
MenuDesAides
$MenuAide add command -label {Ocaml} -underline 0 -command \
     [list EditerFichierAide [NomFichierComplet ocaml.aid]]

EnvoiOcaml ""
set Resultats $ww.text

















