set nomfichier {sans nom}
set MaxNombreFichiers 9
set NombreFichiers 0
set sansnom 1
set decalage 15
set largeur_ecran [winfo screenwidth .]
set hauteur_ecran [winfo screenheight .]
set hauteur_texte [expr $hauteur_ecran/2]
set RechercheReg 0
set RechercheCasse 0
set RechercheTexte {}
set NomRepertoire [pwd]
set typesfichiers {
    {{Tous fichiers}   *}
    {{Fichiers Latex}  {.tex}}
    {{Fichiers Tcl}   {.tcl .tk}}
    {{Fichiers Caml}  {.ml .mli}}
    {{Fichiers de macros}  {.mac}}
    {{Fichiers Textes}  {.txt}}}
set ValTabulation 2
set SauvegardeAuto 0
set SauvegardeAquerir 0

#     *********************************************
#     Noms de fichiers
#     *********************************************

set CheminAbsolu [file dirname [info script]]

proc NomFichierComplet {nom} {
  global CheminAbsolu
  file join $CheminAbsolu $nom
}

proc MAJmenudesfichiers {} {
  global w nomdesfichiers indexdesfichiers NombreFichiers MaxNombreFichiers \
    MenuFichier IndiceF3
  if {[llength $nomdesfichiers]>$MaxNombreFichiers} {
    set nomdesfichiers [lrange $nomdesfichiers 1 end]
    set indexdesfichiers [lrange $indexdesfichiers 1 end]
  }
  set i 0
  set j 10
  foreach nom $nomdesfichiers {
    if {$i < $NombreFichiers} {
      $MenuFichier entryconfigure $j -label "[expr $i+1] $nom"
    } else {
      $MenuFichier add command -label "[expr $i+1] $nom" -command \
        [list MenuOuvrirBool $w.text 1 0 $i] -underline 0
    }
    if {$i == [llength $nomdesfichiers]-1} {
      $MenuFichier entryconfigure $j -accelerator {(F3)}
      set IndiceF3 $j
      bind $w.text <F3> {$MenuFichier invoke $IndiceF3 ; break}
    } else {
      $MenuFichier entryconfigure $j -accelerator ""
    }
    incr i
    incr j
  }
  set NombreFichiers [llength $nomdesfichiers]
}


#     *********************************************
#     Procedures du menu fichier
#     *********************************************

proc Saq {} {
  global SauvegardeAquerir
  set SauvegardeAquerir 1
}

proc Saq0 {} {
  global SauvegardeAquerir
  set SauvegardeAquerir 0
}

proc Enregistrer {w} {
  global nomfichier
  Saq0
  set f [open $nomfichier w]
  puts $f [$w get 1.0 end]
  close $f
}

proc MenuEnregistrerSous {w} {
  global nomfichier NomRepertoire sansnom  typesfichiers
  set nomfichierprov [tk_getSaveFile -filetypes $typesfichiers -initialdir $NomRepertoire]
  if {$nomfichierprov != ""} {
    set nomfichier $nomfichierprov
    set NomRepertoire [file dirname $nomfichier]
    set sansnom 0
    Enregistrer $w
    wm title . "Editeur - $nomfichier"
  }
}

proc MenuEnregistrer {w} {
  global sansnom
  if $sansnom {MenuEnregistrerSous $w} {Enregistrer $w}
}

proc EnregistrerAuto {w} {
  global SauvegardeAuto sansnom nomdesfichiers indexdesfichiers \
    MenuFichier nomfichier  SauvegardeAquerir
    set answer 0
    if {!$SauvegardeAuto && $SauvegardeAquerir} {
      set ans \
        [tk_messageBox -message "Enregistrer?" -type yesno -icon question]
      set answer [string equal $ans yes]
    }
  if {$SauvegardeAquerir && ($SauvegardeAuto || $answer)} {MenuEnregistrer $w}
  if {!$sansnom} {
    set i [lsearch -exact $nomdesfichiers $nomfichier]
    if {$i>=0} {
      set nomdesfichiers [lreplace $nomdesfichiers $i $i]
      set indexdesfichiers [lreplace $indexdesfichiers $i $i]
    }
    lappend nomdesfichiers $nomfichier
    lappend indexdesfichiers [$w index insert]
    MAJmenudesfichiers
  }
}

proc MenuNouveau {w} {
  global nomfichier sansnom
  EnregistrerAuto $w
  Saq0
  $w delete 1.0 end
  set nomfichier {sans nom}
  set sansnom 1
  wm title . "Editeur - $nomfichier"
}

proc MenuOuvrirBool {w bool bool2 i} {
  global nomfichier NomRepertoire sansnom typesfichiers \
    nomdesfichiers indexdesfichiers
  if {$bool2} {
    set nomfichierprov [tk_getOpenFile -filetypes $typesfichiers -initialdir $NomRepertoire]
    set ifp 1.0
    } {
    set nomfichierprov [lindex $nomdesfichiers $i]
    set ifp [lindex $indexdesfichiers $i]
  }
  if {$nomfichierprov != ""} {
    if $bool {
      EnregistrerAuto $w
      Saq0
      $w delete 1.0 end
      set nomfichier $nomfichierprov
      set sansnom 0
      wm title . "Editeur - $nomfichier"
    } {Saq}
    set NomRepertoire [file dirname $nomfichierprov]
    set f [open $nomfichierprov r]
    while {[gets $f line] >= 0} {
      $w insert insert "$line\n"
    }
    close $f
    if $bool {
      $w mark set insert $ifp
      $w see insert
    }
  }
}

proc MenuOuvrir {w} {MenuOuvrirBool $w 1 1 0}
proc MenuInsere {w} {MenuOuvrirBool $w 0 1 0}

proc MenuQuitter {w} {
 global nomdesfichiers
 EnregistrerAuto $w
 set f [open [NomFichierComplet historic.txt] w]
 set i 0
 foreach nom $nomdesfichiers {
   puts $f $nom
   incr i
 }
 close $f
 destroy .
}


#   *************************************************************
#   Macro commande Ctrl M ......... Ctrl M Ctrl E (comme dans "E")
#   *************************************************************

set MacroME {}
set ModeMacroME 0

bind EnregistreMacroME <Control-Key> {
  if {![regexp {Control_|^e$|^E$|^m$|^M$} "%K"]} {
    if {"%K" == "Alt_L"} {
      set AltGrad 1
    } {
      lappend MacroME Control-%K
    }
  }
}
bind EnregistreMacroME <Shift-Key> {
  if {![regexp Shift "%K"]} {
    if [regexp {^[A-B]$|^[0-9]$} "%K"] {
      lappend MacroME %K
    } {
      lappend MacroME Shift-%K
    }
  }
}
bind EnregistreMacroME <Alt-Key> {
  if {![regexp Alt "%K"]} {lappend MacroME Alt-%K}}
bind EnregistreMacroME <Key> {
  if {![regexp Control "%K"] && ![regexp Alt "%K"]} {
    if {$AltGrad} {
      switch -- "%K" {
        eacute     {lappend MacroME "~"}
        quotedbl   {lappend MacroME "#"}
        quoteright {lappend MacroME "\{"}
        parenleft  {lappend MacroME "\["}
        minus      {lappend MacroME "|"}
        egrave     {lappend MacroME "`"}
        underscore {lappend MacroME "\\"}
        ccedilla   {lappend MacroME "^"}
        agrave     {lappend MacroME "@"}
        parenright {lappend MacroME "\]"}
        equal      {lappend MacroME "\}"}
      }
      set AltGrad 0
    } {
      lappend MacroME %K
    }
  }
}

proc DefinirMacroME {w} {
  global MacroME ModeMacroME AltGrad
  if $ModeMacroME {
    set ModeMacroME 0
    bindtags $w [list $w Text . all]
  } else {
    set ModeMacroME 1
    set AltGrad 0
    set MacroME {}
    bindtags $w [list EnregistreMacroME $w Text . all]
  }
}

proc ExecuterMacro {w macro} {
  global EscapeMode NbreCarsLus
  foreach touche $macro {
    if {[string length $touche] == 1} {
      if $EscapeMode {
        incr NbreCarsLus
        event generate $w "<$touche>"
      } {
        $w insert insert $touche
      }
    } {
      event generate $w "<$touche>"
    }
  }
}

proc ExecuterMacroME {w} {
  global MacroME
  ExecuterMacro $w $MacroME
}

#     *********************************************
#     Raccourcis
#     *********************************************

set ModeExecMacEsc 0
set ListeRaccourcis {}

proc ExecuterMacroEscape {w macro l} {
  global ModeMacroME ModeExecMacEsc NbreCarsLus EscapeMode
  if {$NbreCarsLus <= $l} {
    set EscapeMode 0
    set sauve $ModeExecMacEsc
    set ModeExecMacEsc 1
    bindtags $w [list $w Text . all]
    ExecuterMacro $w $macro
    if {$ModeMacroME && !$sauve} {
      bindtags $w [list EnregistreMacroME $w Text . all]
    } {
      bindtags $w [list $w Text . all]
    }
    set ModeExecMacEsc $sauve
  }
}

proc PassageModeEscape {w} {
  global ModeMacroME ModeExecMacEsc NbreCarsLus EscapeMode
  set EscapeMode 1
  set NbreCarsLus 0
  if {$ModeMacroME && !$ModeExecMacEsc} {
    bindtags $w [list ModeEscape EnregistreMacroME]
  } {
    bindtags $w ModeEscape
  }
}

proc InitRaccourcis {w} {
  global NbreCarsLus EscapeMode
  set EscapeMode 0
  bind $w <Escape> [list PassageModeEscape $w]
  bind ModeEscape <Escape> [list ExecuterMacroEscape $w {} 100000]
  bind ModeEscape <Motion> [list ExecuterMacroEscape $w {} 100000]
  bind ModeEscape <KeyRelease> {incr NbreCarsLus}
}

proc LierRaccourciMacro {w raccourci macro} {
  global ListeRaccourcis
  if {[lsearch -exact $ListeRaccourcis $raccourci] < 0} {
    lappend ListeRaccourcis $raccourci
  }
  set l [string length $raccourci]
  bind ModeEscape $raccourci [list ExecuterMacroEscape $w $macro $l]
}

proc SupprimerTousRaccourcis {w} {
  global ListeRaccourcis
  foreach raccourci $ListeRaccourcis {
    bind ModeEscape $raccourci {}
  }
  set ListeRaccourcis {}
}

proc FinAjouterSupprimerRaccourci {w ok ajouter} {
  global MacroME RaccourciCourant ListeRaccourcis CheminAbsolu
  destroy .racc$ajouter
  if {$ok && $RaccourciCourant != ""} {
    if {$ajouter} {
      LierRaccourciMacro $w $RaccourciCourant $MacroME
    } {
      set i [lsearch -exact $ListeRaccourcis $RaccourciCourant]
      if {$i>=0} {
        bind ModeEscape $RaccourciCourant {}
        set ListeRaccourcis [lreplace $ListeRaccourcis $i $i]
      }
    }
  }
}


set RaccourciCourant {}

proc AjouterSupprimerRaccourci {w ajouter} {
  global RaccourciCourant
  set f .racc$ajouter
  if {![winfo exists $f]} {
    toplevel $f
    if $ajouter {
      set titre "Dfinition d'un raccourci"
      set mess "Nom du raccourci ( associer  ESC)"
    } {
      set titre "Suppression d'un raccourci"
      set mess "Nom du raccourci  supprimer"
    } 
    wm title $f "$titre"
    label $f.l -text "$mess" -anchor w
    entry $f.e -textvariable RaccourciCourant
    grid $f.l $f.e -sticky news
    bind $f.e <Return> [list FinAjouterSupprimerRaccourci $w 1 $ajouter]
    bind $f.e <Escape> [list FinAjouterSupprimerRaccourci $w 0 $ajouter]
  }
  focus $f.e
  if {[string compare normal [wm state $f]]} {
        wm deiconify $f
    } else { raise $f}
  $f.e select range 0 end
}

proc DefinirRaccourciMacro {w} {
  AjouterSupprimerRaccourci $w 1
}

proc SupprimerRaccourci {w} {
  AjouterSupprimerRaccourci $w 0
}

proc ChargerFichierRaccourcis {w nomfich} {
  if {$nomfich != ""} {
    set f [open $nomfich r]
    while {[gets $f line] >= 0} {
      if {$line != ""} {
        set raccourci [lindex $line 0]
        set macro [lrange $line 1 end]
        LierRaccourciMacro $w $raccourci $macro
      }
    }
    close $f
  }
}

proc ChargerRaccourcis {w} {
  global CheminAbsolu
  set types {{{Fichiers de macros}  {.mac}}}
  set nomfich [tk_getOpenFile -filetypes $types -initialdir \
                                    [file join $CheminAbsolu macros]]
  ChargerFichierRaccourcis $w $nomfich
}

proc SauvegardeRaccourcis {w} {
  global CheminAbsolu ListeRaccourcis
  set types {{{Fichiers de macros}  {.mac}}}
  set nomfichier [tk_getSaveFile -filetypes $types -initialdir \
                                        [file join $CheminAbsolu macros]]
  if {$nomfichier != ""} {
    set f [open $nomfichier w]
    foreach raccourci $ListeRaccourcis {
      puts $f [linsert [lindex [bind ModeEscape $raccourci] 2] 0 $raccourci]
    }
    close $f
  }
}

proc ListerRaccourcis {w} {
  global ListeRaccourcis
  set l [lsort $ListeRaccourcis]
  tk_messageBox -icon info -message $l -title "Raccourcis disponibles" -type ok
}

#     *********************************************
#     Recherche
#     *********************************************

proc PlacerAuTag {w tag} {
 set IndiceAuxil [lindex [$w tag nextrange $tag "insert +1 chars"] 0]
 if {$IndiceAuxil != ""} {
   $w mark set insert $IndiceAuxil
   $w see insert
 }
}

#     *********************************************
#     Procedures de recherche dans un widget text
#     d'aprs TkCon de Jeffrey Hobbs
#     *********************************************

proc RechercheReturn {w} {
  global RechercheTexte RechercheCasse RechercheReg MenuEdition
  tkConFind $w $RechercheTexte -case $RechercheCasse -reg $RechercheReg
  PlacerAuTag $w find
  $MenuEdition entryconfigure 2 -state normal
  destroy .rechwin
}

proc RechercheEscape {w} {
    global MenuEdition
    $w tag remove find 1.0 end
    $MenuEdition entryconfigure 2 -state disabled
    destroy .rechwin
}

proc tkConFindBox {w {str {}}} {
    global RechercheReg RechercheCasse RechercheTexte MenuEdition
    set base .rechwin
    if {![winfo exists $base]} {
      toplevel $base
      wm withdraw $base
      wm title $base "Recherche"
       pack [frame $base.f] -fill x -expand 1
      label $base.f.l -text "Chercher:"
      entry $base.f.e -textvar RechercheTexte
      pack [frame $base.opt] -fill x
      checkbutton $base.opt.c -text "Respecter la casse" \
              -variable RechercheCasse
      checkbutton $base.opt.r -text "Expression rgulire" -variable RechercheReg
      pack $base.f.l -side left
      pack $base.f.e $base.opt.c $base.opt.r -side left -fill both -expand 1
      bind $base.f.e <Return> [list RechercheReturn $w]
      bind $base.f.e <Escape> [list RechercheEscape $w]
    }
    focus $base.f.e

    if {[string compare normal [wm state $base]]} {
        wm deiconify $base
    } else { raise $base }

    $base.f.e select range 0 end
}

## tkConFind - searches in text widget $w for $str and highlights it
## If $str is empty, it just deletes any highlighting
# ARGS: w       - text widget
#       str     - string to search for
#       -case   TCL_BOOLEAN     whether to be case sensitive    DEFAULT: 0
#       -regexp TCL_BOOLEAN     whether to use $str as pattern  DEFAULT: 0
##
proc tkConFind {w str args} {
    global MenuEdition
    $w tag remove find 1.0 end
    $MenuEdition entryconfigure 2 -state disabled
    set truth {^(1|yes|true|on)$}
    set opts  {}
    foreach {key val} $args {
        switch -glob -- $key {
            -c* { if {[regexp -nocase $truth $val]} { set case 1 } }
            -r* { if {[regexp -nocase $truth $val]} { lappend opts -regexp } }
            default { return -code error "Unknown option $key" }
        }
    }
    if {![info exists case]} { lappend opts -nocase }
    if {[string match {} $str]} return
    $w mark set findmark 1.0
    while {[string compare {} [set ix [eval $w search $opts -count numc -- \
            [list $str] findmark end]]]} {
        $w tag add find $ix ${ix}+${numc}c
        $w mark set findmark ${ix}+1c
    }
    $w tag configure find -background yellow
    catch {$w see find.first}
    return [expr {[llength [$w tag ranges find]]/2}]
}

#   *************************************************************
#   Retours  la ligne automatiques
#   *************************************************************

set RetourLigne 0

proc ConfigRetourLigne {} {
  global RetourLigne w
  if {$RetourLigne} {set o word} {set o none}
  $w.text configure -wrap $o
}


#   *************************************************************
#   Aide
#   *************************************************************

set NombreAides 0

proc EditerFichierAide {nom} {
  global largeur_ecran hauteur_ecran NombreAides
  if {[catch {open $nom r} f]==0} {
    incr NombreAides
    set aid .aide$NombreAides
    toplevel $aid
    wm title $aid Aide
    wm positionfrom $aid user
    wm sizefrom $aid user
    wm geometry $aid [expr $largeur_ecran*7/8]x[expr $hauteur_ecran*3/4]+[expr $largeur_ecran/16]+[expr $hauteur_ecran/8]
    set w $aid.ff
    frame $w
    pack configure $w -side left -fill both -expand 1
    scrollbar $w.scrollv -orient vertical -command "$w.text yview"
    pack configure $w.scrollv -side right -fill y -expand 1
    pack configure $w -side top -expand 1 -fill both
    text $w.text -background white -relief raised -bd 2 -wrap word \
     -font {-family courier -size 10} -yscrollcommand "$w.scrollv set" \
     -cursor arrow
    set w $w.text
    pack $w -expand yes -fill both
    $w tag configure bleu -foreground blue
    while {[gets $f line] >= 0} {
      set longueur [string length $line]
      set k 0
      while {$k < $longueur} {
        set i [string first "<*" [string range $line $k end]]
        if {$i >= 0} {
          $w insert insert [string range $line $k [expr $k + $i - 1]]
          incr k $i
          if {[string equal [string index $line [expr $k + 2]] "*"]} {
            incr k 3
            set i [expr $k + [string first ">" [string range $line $k end]] - 1]
            set nom [string range $line $k $i]
            if ![info exists NumTag$nom] {
              set NumTag$nom 0
            } {
              incr NumTag$nom
            }
            set nt NumTag$nom
            set nomtag T$nom[subst $$nt]
            set k [expr $i + 2]
            set i [expr $k + [string first "<" [string range $line $k end]] - 1]
            $w insert insert [string range $line $k $i] [list $nomtag bleu]
            $w tag bind $nomtag <Enter> [list $w tag configure $nomtag -foreground red]
            $w tag bind $nomtag <Leave> [list $w tag configure $nomtag -foreground blue]
            $w tag bind $nomtag <Button-1> [list $w yview M$nom]
            set k [expr $i + 4]
          } else {
            incr k 2
            set i [expr $k + [string first ">" [string range $line $k end]] - 1]
            set nom [string range $line $k $i]
            $w mark set M$nom insert
            $w mark gravity M$nom left
            set k [expr $i + 2]
          }
        } else {
          $w insert insert "[string range $line $k end]"
          set k $longueur
        }
      }
      $w insert insert "\n"
    }
    close $f
    $w configure -state disabled
  } else {
    tk_messageBox -message "fichier $nom non trouv" -type ok -icon error
  }
}

#   *************************************************************
#   Fenetres, menu, liens
#   *************************************************************

wm title . "Editeur - $nomfichier"
wm positionfrom . user
wm sizefrom . user
wm geometry . [expr $largeur_ecran]x[expr $hauteur_texte]+0+0
wm protocol . WM_DELETE_WINDOW {MenuQuitter $w.text}

set w .f
frame $w
pack configure $w -side left -fill both -expand 1
scrollbar $w.scrollv -orient vertical -command "$w.text yview"
pack configure $w.scrollv -side right -fill y -expand 1
scrollbar $w.scrollh -orient horizontal -command "$w.text xview"
pack configure $w.scrollh -side bottom -fill x -expand 1
pack configure $w -side top -expand 1 -fill both

text $w.text -relief sunken -bd 2 -wrap none -font {-family courier -size 10} \
 -yscrollcommand "$w.scrollv set" -xscrollcommand "$w.scrollh set"

label $w.coords  -textvariable coords -relief groove
pack configure $w.coords -side bottom

set coords " 1.0 "
proc MiseAJourCoords {} {
 global w coords
 set coords " [$w.text index insert] "
}
event add <<ChgtCoords>> <KeyRelease> <ButtonRelease>
bind $w.text <<ChgtCoords>> {MiseAJourCoords}

pack $w.text -expand yes -fill both
focus $w.text
raise .

menu $w.menubar
. config -menu $w.menubar
 set MenuFichier [menu $w.menubar.fichier -tearoff 1]
  $w.menubar add cascade -label Fichier -underline 0 -menu $MenuFichier
  $MenuFichier add command -label Nouveau -underline 0 -command \
    [list MenuNouveau $w.text]
  $MenuFichier add command -label Ouvrir -underline 0 -command \
    [list MenuOuvrir $w.text]
  $MenuFichier add command -label Insrer -underline 0 -command \
    [list MenuInsere $w.text]
  $MenuFichier add command -label Enregistrer -underline 0 \
    -accelerator {(F2)} -command [list MenuEnregistrer $w.text]
    bind $w.text <F2> {$MenuFichier invoke 4; break}
  $MenuFichier add command -label {Enregistrer sous} -underline 2 -command \
    [list MenuEnregistrerSous $w.text]
  $MenuFichier add checkbutton -label {Enregistrements automatiques} \
    -variable SauvegardeAuto -background grey65
  $MenuFichier add separator
  $MenuFichier add command -label Quitter -underline 0 -command {
    MenuQuitter $w.text}
  $MenuFichier add separator
 set MenuEdition [menu $w.menubar.edition -tearoff 1]
  $w.menubar add cascade -label Edition -underline 0 -menu $MenuEdition
  $MenuEdition add command -label Rechercher \
    -accelerator {(Ctrl R)} -command {
     tkConFindBox $w.text}
    bind $w.text <Control-Key-r> {$MenuEdition invoke 1; break}
  $MenuEdition add command -label {Recherche suivante} \
    -state disabled -accelerator {(Ctrl S)} -command {
     PlacerAuTag $w.text find}
    bind $w.text <Control-s> {$MenuEdition invoke 2; break}
  $MenuEdition add separator
  $MenuEdition add command -label {Dfinir macro} \
    -accelerator {(Ctrl M)} -state normal -command {
     DefinirMacroME $w.text
     $MenuEdition entryconfigure 4 -state disabled
     $MenuEdition entryconfigure 5 -state normal
     $MenuEdition entryconfigure 6 -state disabled
     $MenuEdition entryconfigure 7 -state disabled}
  $MenuEdition add command -label {Fin de dfinition de macro} \
    -accelerator {(Ctrl M)} -state disabled -command {
     DefinirMacroME $w.text
     $MenuEdition entryconfigure 4 -state normal
     $MenuEdition entryconfigure 5 -state disabled
     $MenuEdition entryconfigure 6 -state normal
     $MenuEdition entryconfigure 7 -state normal}
  $MenuEdition add command -label {Excuter macro} \
    -accelerator {(Ctrl E)} -state disabled -command {ExecuterMacroME $w.text}
  bind $w.text <Control-m> {
    if $ModeMacroME {$MenuEdition invoke 5} {$MenuEdition invoke 4}
    break
  }
  bind $w.text <Control-e> {ExecuterMacroME $w.text; break}
  $MenuEdition add command -label {Associer macro  un raccourci} \
    -accelerator {(Ctrl Z)} -state disabled -command {DefinirRaccourciMacro $w.text}
  bind $w.text <Control-z> {$MenuEdition invoke 7}
  $MenuEdition add command -label {Supprimer un raccourci} \
    -underline 0 -command {SupprimerRaccourci $w.text}
  $MenuEdition add command -label {Supprimer tous les raccourcis} \
    -command {SupprimerTousRaccourcis $w.text}
  $MenuEdition add command -label {Liste des raccourcis} \
    -underline 0 -command {ListerRaccourcis $w.text} 
  $MenuEdition add command -label {Enregistrer les raccourcis} \
    -underline 0 -command {SauvegardeRaccourcis $w.text}
  $MenuEdition add command -label {Ouvrir un fichier de raccourcis} \
    -underline 0 -command {ChargerRaccourcis $w.text}
  $MenuEdition add separator
  $MenuEdition add checkbutton -label {Retour  la ligne automatique} \
    -underline 0 -variable RetourLigne -background grey65 -command \
    {ConfigRetourLigne}
proc MenuDesAides {} {
  global w MenuAide
  set MenuAide [menu $w.menubar.aide -tearoff 1]
  $w.menubar add cascade -label Aide -underline 0 -menu $MenuAide
  $MenuAide add command -label {Editeur} -underline 0 -command \
     [list EditerFichierAide [NomFichierComplet texte.aid]]
}

proc LigneSuivante {} {
  global w
  Saq
  set ligne [$w.text get "insert linestart" "insert lineend"]
  set long [string length $ligne]
  set n [expr $long-[string length [string trimleft $ligne]]]
  if {$n==$long} {set n 0}
  $w.text insert insert "\n[string repeat " " $n]"
  $w.text see insert
}

proc InitTexte {w} {
  global nomdesfichiers indexdesfichiers argv argvbis ApplicationSecondaire
  if {![info exists ApplicationSecondaire]} [MenuDesAides]
  InitRaccourcis $w
  set historique [NomFichierComplet historic.txt]
  set argvbis {}
  for {set i 0} {$i < [llength $argv]} {incr i} {
    set option [lindex $argv $i]
    switch -- $option {
      "-f" {
        incr i
        set historique [lindex $argv $i]
      }
      "-m" {
        incr i
        ChargerFichierRaccourcis $w [lindex $argv $i]
      }
      default {
        lappend argvbis $option
      }
    }
  }
  set nomdesfichiers {}
  set indexdesfichiers {}
  if {[catch {open $historique r} f]==0} {
    while {[gets $f line] >= 0} {
      lappend nomdesfichiers $line
      lappend indexdesfichiers "1.0"
    }
  }
  MAJmenudesfichiers
}

InitTexte $w.text

proc Tabulation {} {
  global w ValTabulation
  Saq
  $w.text insert insert "[string repeat " " $ValTabulation]"
  $w.text see insert
}

bind $w.text <KeyPress> {
  if {( "%A" != "{}" || "%K" == "Delete" ) && [focus] == "$w.text"} {
    Saq
  }
}

bind $w.text <Return> {LigneSuivante; break}
bind $w.text <Tab> {Tabulation; break}




